Index: uspace/app/terminal/terminal.c
===================================================================
--- uspace/app/terminal/terminal.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/terminal/terminal.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2012 Petr Koupy
  * All rights reserved.
@@ -37,4 +37,5 @@
 #include <adt/list.h>
 #include <adt/prodcons.h>
+#include <as.h>
 #include <errno.h>
 #include <fbfont/font-8x16.h>
@@ -42,4 +43,5 @@
 #include <gfx/bitmap.h>
 #include <gfx/context.h>
+#include <gfx/render.h>
 #include <io/con_srv.h>
 #include <io/concaps.h>
@@ -48,4 +50,5 @@
 #include <task.h>
 #include <stdarg.h>
+#include <stdio.h>
 #include <stdlib.h>
 #include <str.h>
@@ -85,4 +88,8 @@
 static void term_set_cursor_visibility(con_srv_t *, bool);
 static errno_t term_get_event(con_srv_t *, cons_event_t *);
+static errno_t term_map(con_srv_t *, sysarg_t, sysarg_t, charfield_t **);
+static void term_unmap(con_srv_t *);
+static void term_buf_update(con_srv_t *, sysarg_t, sysarg_t, sysarg_t,
+    sysarg_t);
 
 static con_ops_t con_ops = {
@@ -101,5 +108,8 @@
 	.set_rgb_color = term_set_rgb_color,
 	.set_cursor_visibility = term_set_cursor_visibility,
-	.get_event = term_get_event
+	.get_event = term_get_event,
+	.map = term_map,
+	.unmap = term_unmap,
+	.update = term_buf_update
 };
 
@@ -331,6 +341,6 @@
 
 	bool update = false;
-	sysarg_t sx = 0/*term->widget.hpos*/;
-	sysarg_t sy = 0/*term->widget.vpos*/;
+	sysarg_t sx = 0;
+	sysarg_t sy = 0;
 
 	if (term_update_scroll(term, &pixelmap, sx, sy)) {
@@ -343,5 +353,5 @@
 				charfield_t *back_field =
 				    chargrid_charfield_at(term->backbuf, x, y);
-				bool update = false;
+				bool cupdate = false;
 
 				if ((front_field->flags & CHAR_FLAG_DIRTY) ==
@@ -349,5 +359,5 @@
 					if (front_field->ch != back_field->ch) {
 						back_field->ch = front_field->ch;
-						update = true;
+						cupdate = true;
 					}
 
@@ -355,5 +365,5 @@
 					    back_field->attrs)) {
 						back_field->attrs = front_field->attrs;
-						update = true;
+						cupdate = true;
 					}
 
@@ -361,5 +371,5 @@
 				}
 
-				if (update) {
+				if (cupdate) {
 					term_update_char(term, &pixelmap, sx, sy, x, y);
 					update = true;
@@ -524,4 +534,5 @@
 		term_write_char(term, str_decode(data, &off, size));
 
+	gfx_update(term->gc);
 	*nwritten = size;
 	return EOK;
@@ -533,4 +544,5 @@
 
 	term_update(term);
+	gfx_update(term->gc);
 }
 
@@ -544,4 +556,5 @@
 
 	term_update(term);
+	gfx_update(term->gc);
 }
 
@@ -555,4 +568,5 @@
 
 	term_update(term);
+	gfx_update(term->gc);
 }
 
@@ -626,4 +640,5 @@
 
 	term_update(term);
+	gfx_update(term->gc);
 }
 
@@ -637,4 +652,119 @@
 	free(ev);
 	return EOK;
+}
+
+/** Create shared buffer for efficient rendering.
+ *
+ * @param srv Console server
+ * @param cols Number of columns in buffer
+ * @param rows Number of rows in buffer
+ * @param rbuf Place to store pointer to new sharable buffer
+ *
+ * @return EOK on sucess or an error code
+ */
+static errno_t term_map(con_srv_t *srv, sysarg_t cols, sysarg_t rows,
+    charfield_t **rbuf)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	void *buf;
+
+	fibril_mutex_lock(&term->mtx);
+
+	if (term->ubuf != NULL) {
+		fibril_mutex_unlock(&term->mtx);
+		return EBUSY;
+	}
+
+	buf = as_area_create(AS_AREA_ANY, cols * rows * sizeof(charfield_t),
+	    AS_AREA_READ | AS_AREA_WRITE | AS_AREA_CACHEABLE, AS_AREA_UNPAGED);
+	if (buf == AS_MAP_FAILED) {
+		fibril_mutex_unlock(&term->mtx);
+		return ENOMEM;
+	}
+
+	term->ucols = cols;
+	term->urows = rows;
+	term->ubuf = buf;
+	fibril_mutex_unlock(&term->mtx);
+
+	*rbuf = buf;
+	return EOK;
+}
+
+/** Delete shared buffer.
+ *
+ * @param srv Console server
+ */
+static void term_unmap(con_srv_t *srv)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	void *buf;
+
+	fibril_mutex_lock(&term->mtx);
+
+	buf = term->ubuf;
+	term->ubuf = NULL;
+
+	if (buf != NULL)
+		as_area_destroy(buf);
+
+	fibril_mutex_unlock(&term->mtx);
+}
+
+/** Update area of terminal from shared buffer.
+ *
+ * @param srv Console server
+ * @param c0 Column coordinate of top-left corner (inclusive)
+ * @param r0 Row coordinate of top-left corner (inclusive)
+ * @param c1 Column coordinate of bottom-right corner (exclusive)
+ * @param r1 Row coordinate of bottom-right corner (exclusive)
+ */
+static void term_buf_update(con_srv_t *srv, sysarg_t c0, sysarg_t r0,
+    sysarg_t c1, sysarg_t r1)
+{
+	terminal_t *term = srv_to_terminal(srv);
+	charfield_t *ch;
+	sysarg_t col, row;
+
+	fibril_mutex_lock(&term->mtx);
+
+	if (term->ubuf == NULL) {
+		fibril_mutex_unlock(&term->mtx);
+		return;
+	}
+
+	/* Make sure we have meaningful coordinates, within bounds */
+
+	if (c1 > term->ucols)
+		c1 = term->ucols;
+	if (c1 > term->cols)
+		c1 = term->cols;
+	if (c0 >= c1) {
+		fibril_mutex_unlock(&term->mtx);
+		return;
+	}
+	if (r1 > term->urows)
+		r1 = term->urows;
+	if (r1 > term->rows)
+		r1 = term->rows;
+	if (r0 >= r1) {
+		fibril_mutex_unlock(&term->mtx);
+		return;
+	}
+
+	/* Update front buffer from user buffer */
+
+	for (row = r0; row < r1; row++) {
+		for (col = c0; col < c1; col++) {
+			ch = chargrid_charfield_at(term->frontbuf, col, row);
+			*ch = term->ubuf[row * term->ucols + col];
+		}
+	}
+
+	fibril_mutex_unlock(&term->mtx);
+
+	/* Update terminal */
+	term_update(term);
+	gfx_update(term->gc);
 }
 
@@ -688,4 +818,5 @@
 	term->is_focused = true;
 	term_update(term);
+	gfx_update(term->gc);
 }
 
@@ -712,5 +843,5 @@
 	sysarg_t sy = -term->off.y;
 
-	if (event->type == POS_PRESS) {
+	if (event->type == POS_PRESS || event->type == POS_RELEASE) {
 		cevent.type = CEV_POS;
 		cevent.ev.pos.type = event->type;
@@ -731,4 +862,5 @@
 	term->is_focused = false;
 	term_update(term);
+	gfx_update(term->gc);
 }
 
Index: uspace/app/terminal/terminal.h
===================================================================
--- uspace/app/terminal/terminal.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/terminal/terminal.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2019 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2012 Petr Koupy
  * All rights reserved.
@@ -85,4 +85,8 @@
 	sysarg_t top_row;
 
+	sysarg_t ucols;
+	sysarg_t urows;
+	charfield_t *ubuf;
+
 	service_id_t dsid;
 	con_srvs_t srvs;
Index: uspace/app/tester/ipc/starve.c
===================================================================
--- uspace/app/tester/ipc/starve.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/tester/ipc/starve.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -57,7 +57,12 @@
 		cons_event_t ev;
 		usec_t timeout = 0;
-		bool has_event = console_get_event_timeout(console, &ev, &timeout);
-		if (has_event && ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
-			TPRINTF("Key %d pressed, terminating.\n", ev.ev.key.key);
+		errno_t rc = console_get_event_timeout(console, &ev, &timeout);
+		if (rc == EOK) {
+			if (ev.type == CEV_KEY && ev.ev.key.type == KEY_PRESS) {
+				TPRINTF("Key %d pressed, terminating.\n", ev.ev.key.key);
+				break;
+			}
+		} else if (rc != ETIMEOUT) {
+			TPRINTF("Got rc=%d, terminating.\n", rc);
 			break;
 		}
Index: uspace/app/tetris/scores.c
===================================================================
--- uspace/app/tetris/scores.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/tetris/scores.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -126,4 +126,5 @@
 	cons_event_t ev;
 	kbd_event_t *kev;
+	errno_t rc;
 
 	clear_screen();
@@ -141,5 +142,6 @@
 	while (true) {
 		console_flush(console);
-		if (!console_get_event(console, &ev))
+		rc = console_get_event(console, &ev);
+		if (rc != EOK)
 			exit(1);
 
Index: uspace/app/tetris/screen.c
===================================================================
--- uspace/app/tetris/screen.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/tetris/screen.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -54,4 +54,5 @@
  */
 
+#include <errno.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -71,5 +72,6 @@
 static int isset;               /* true => terminal is in game mode */
 
-static bool use_color;          /* true => use colors */
+static bool use_rgb;          /* true => use RGB colors */
+static bool use_color;          /* true => use indexed colors */
 
 static const struct shape *lastshape;
@@ -91,7 +93,21 @@
 static void start_standout(uint32_t color)
 {
+	uint8_t bg;
+	uint8_t attr;
+
 	console_flush(console);
-	console_set_rgb_color(console, use_color ? color : 0x000000,
-	    0xffffff);
+	if (use_rgb) {
+		console_set_rgb_color(console, color, 0xffffff);
+	} else if (use_color) {
+		bg = 0x00;
+		attr = 0;
+		if ((color & 0xff0000) != 0)
+			bg |= 0x4;
+		if ((color & 0x00ff00) != 0)
+			bg |= 0x2;
+		if ((color & 0x0000ff) != 0)
+			bg |= 0x1;
+		console_set_color(console, bg, 0x00, attr);
+	}
 }
 
@@ -142,13 +158,17 @@
 }
 
-static bool get_display_color_sup(void)
+static void get_display_color_sup(bool *rgb, bool *color)
 {
 	sysarg_t ccap;
 	errno_t rc = console_get_color_cap(console, &ccap);
 
-	if (rc != EOK)
-		return false;
-
-	return ((ccap & CONSOLE_CAP_RGB) == CONSOLE_CAP_RGB);
+	if (rc != EOK) {
+		*rgb = false;
+		*color = false;
+		return;
+	}
+
+	*rgb = ((ccap & CONSOLE_CAP_RGB) == CONSOLE_CAP_RGB);
+	*color = ((ccap & CONSOLE_CAP_INDEXED) == CONSOLE_CAP_INDEXED);
 }
 
@@ -168,5 +188,5 @@
 	}
 
-	use_color = get_display_color_sup();
+	get_display_color_sup(&use_rgb, &use_color);
 
 	if ((Rows < MINROWS) || (Cols < MINCOLS)) {
@@ -340,10 +360,14 @@
 {
 	usec_t timeout = fallrate;
+	errno_t rc;
 
 	while (timeout > 0) {
 		cons_event_t event;
 
-		if (!console_get_event_timeout(console, &event, &timeout))
+		rc = console_get_event_timeout(console, &event, &timeout);
+		if (rc == ETIMEOUT)
 			break;
+		if (rc != EOK)
+			exit(1);
 	}
 }
@@ -354,4 +378,6 @@
 int tgetchar(void)
 {
+	errno_t rc;
+
 	/*
 	 * Reset timeleft to fallrate whenever it is not positive
@@ -376,8 +402,11 @@
 		cons_event_t event;
 
-		if (!console_get_event_timeout(console, &event, &timeleft)) {
+		rc = console_get_event_timeout(console, &event, &timeleft);
+		if (rc == ETIMEOUT) {
 			timeleft = 0;
 			return -1;
 		}
+		if (rc != EOK)
+			exit(1);
 
 		if (event.type == CEV_KEY && event.ev.key.type == KEY_PRESS)
@@ -394,10 +423,14 @@
 {
 	char32_t c = 0;
+	errno_t rc;
 
 	while (c == 0) {
 		cons_event_t event;
 
-		if (!console_get_event(console, &event))
+		rc = console_get_event(console, &event);
+		if (rc == ETIMEOUT)
 			return -1;
+		if (rc != EOK)
+			exit(1);
 
 		if (event.type == CEV_KEY && event.ev.key.type == KEY_PRESS)
Index: uspace/app/tetris/tetris.c
===================================================================
--- uspace/app/tetris/tetris.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/tetris/tetris.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -202,4 +202,6 @@
 	while (true) {
 		int i = getchar();
+		if (i < 0)
+			return 0;
 
 		switch (i) {
Index: uspace/app/top/screen.c
===================================================================
--- uspace/app/top/screen.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/top/screen.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -534,7 +534,12 @@
 /** Get char with timeout
  *
+ * @param sec Timeout in seconds
+ * @param rch Place to store character on success
+ * @return EOK on success, ETIMEOUT on time out, EIO on other error
  */
-int tgetchar(sec_t sec)
-{
+errno_t tgetchar(sec_t sec, int *rch)
+{
+	errno_t rc;
+
 	/*
 	 * Reset timeleft whenever it is not positive.
@@ -548,5 +553,5 @@
 	 * update timeleft so that the next call to tgetchar()
 	 * will not wait as long. If there is no input,
-	 * make timeleft zero and return -1.
+	 * make timeleft zero and return ETIMEOUT.
 	 */
 
@@ -557,8 +562,13 @@
 
 		warning_timeleft -= timeleft;
-		if (!console_get_event_timeout(console, &event, &timeleft)) {
+		rc = console_get_event_timeout(console, &event, &timeleft);
+		if (rc == ETIMEOUT) {
 			timeleft = 0;
-			return -1;
-		}
+			return ETIMEOUT;
+		}
+
+		if (rc != EOK)
+			return EIO;
+
 		warning_timeleft += timeleft;
 
@@ -567,5 +577,6 @@
 	}
 
-	return (int) c;
+	*rch = (int) c;
+	return EOK;
 }
 
Index: uspace/app/top/screen.h
===================================================================
--- uspace/app/top/screen.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/top/screen.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -35,4 +35,5 @@
 #define TOP_SCREEN_H_
 
+#include <errno.h>
 #include <io/console.h>
 #include <io/verify.h>
@@ -47,5 +48,5 @@
     _HELENOS_PRINTF_ATTRIBUTE(1, 2);
 
-extern int tgetchar(sec_t);
+extern errno_t tgetchar(sec_t, int *);
 
 #endif
Index: uspace/app/top/top.c
===================================================================
--- uspace/app/top/top.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/top/top.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -583,4 +583,6 @@
 	data_t data_prev;
 	const char *ret = NULL;
+	errno_t rc;
+	int c;
 
 	screen_init();
@@ -595,7 +597,7 @@
 	/* And paint screen until death */
 	while (true) {
-		int c = tgetchar(UPDATE_INTERVAL);
-
-		if (c < 0) { /* timeout */
+		rc = tgetchar(UPDATE_INTERVAL, &c);
+
+		if (rc == ETIMEOUT) { /* timeout */
 			data_prev = data;
 			if ((ret = read_data(&data)) != NULL) {
@@ -608,4 +610,7 @@
 
 			c = -1;
+		} else if (rc != EOK) {
+			/* Error (e.g. communication with console lost) */
+			goto out;
 		}
 
Index: uspace/app/trace/trace.c
===================================================================
--- uspace/app/trace/trace.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/trace/trace.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -511,4 +511,5 @@
 {
 	cons_event_t event;
+	errno_t rc;
 
 	(void) arg;
@@ -522,5 +523,6 @@
 		fibril_mutex_unlock(&state_lock);
 
-		if (!console_get_event(console, &event))
+		rc = console_get_event(console, &event);
+		if (rc != EOK)
 			return EINVAL;
 
Index: uspace/app/uidemo/uidemo.c
===================================================================
--- uspace/app/uidemo/uidemo.c	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/uidemo/uidemo.c	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,9 +37,15 @@
 #include <io/pixelmap.h>
 #include <stdio.h>
+#include <stdlib.h>
 #include <str.h>
 #include <ui/entry.h>
+#include <ui/filedialog.h>
 #include <ui/fixed.h>
 #include <ui/image.h>
 #include <ui/label.h>
+#include <ui/menubar.h>
+#include <ui/menuentry.h>
+#include <ui/menu.h>
+#include <ui/msgdialog.h>
 #include <ui/pbutton.h>
 #include <ui/resource.h>
@@ -62,4 +68,51 @@
 };
 
+static void checkbox_switched(ui_checkbox_t *, void *, bool);
+
+static ui_checkbox_cb_t checkbox_cb = {
+	.switched = checkbox_switched
+};
+
+static void rb_selected(ui_rbutton_group_t *, void *, void *);
+
+static ui_rbutton_group_cb_t rbutton_group_cb = {
+	.selected = rb_selected
+};
+
+static void slider_moved(ui_slider_t *, void *, gfx_coord_t);
+
+static ui_slider_cb_t slider_cb = {
+	.moved = slider_moved
+};
+
+static void uidemo_file_load(ui_menu_entry_t *, void *);
+static void uidemo_file_message(ui_menu_entry_t *, void *);
+static void uidemo_file_exit(ui_menu_entry_t *, void *);
+
+static void file_dialog_bok(ui_file_dialog_t *, void *, const char *);
+static void file_dialog_bcancel(ui_file_dialog_t *, void *);
+static void file_dialog_close(ui_file_dialog_t *, void *);
+
+static ui_file_dialog_cb_t file_dialog_cb = {
+	.bok = file_dialog_bok,
+	.bcancel = file_dialog_bcancel,
+	.close = file_dialog_close
+};
+
+static void msg_dialog_button(ui_msg_dialog_t *, void *, unsigned);
+static void msg_dialog_close(ui_msg_dialog_t *, void *);
+
+static ui_msg_dialog_cb_t msg_dialog_cb = {
+	.button = msg_dialog_button,
+	.close = msg_dialog_close
+};
+
+/** Horizontal alignment selected by each radio button */
+static const gfx_halign_t uidemo_halign[3] = {
+	gfx_halign_left,
+	gfx_halign_center,
+	gfx_halign_right
+};
+
 /** Window close button was clicked.
  *
@@ -88,11 +141,249 @@
 		if (rc != EOK)
 			printf("Error changing entry text.\n");
-		(void) ui_entry_paint(demo->entry);
 	} else {
 		rc = ui_entry_set_text(demo->entry, "Cancel pressed");
 		if (rc != EOK)
 			printf("Error changing entry text.\n");
-		(void) ui_entry_paint(demo->entry);
-	}
+	}
+}
+
+/** Check box was switched.
+ *
+ * @param checkbox Check box
+ * @param arg Argument (demo)
+ */
+static void checkbox_switched(ui_checkbox_t *checkbox, void *arg, bool enable)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	ui_entry_set_read_only(demo->entry, enable);
+}
+
+/** Radio button was selected.
+ *
+ * @param rbgroup Radio button group
+ * @param garg Group argument (demo)
+ * @param barg Button argument
+ */
+static void rb_selected(ui_rbutton_group_t *rbgroup, void *garg, void *barg)
+{
+	ui_demo_t *demo = (ui_demo_t *) garg;
+	gfx_halign_t halign = *(gfx_halign_t *) barg;
+
+	ui_entry_set_halign(demo->entry, halign);
+	(void) ui_entry_paint(demo->entry);
+}
+
+/** Slider was moved.
+ *
+ * @param slider Slider
+ * @param arg Argument (demo)
+ * @param pos Position
+ */
+static void slider_moved(ui_slider_t *slider, void *arg, gfx_coord_t pos)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	char *str;
+	errno_t rc;
+	int rv;
+
+	rv = asprintf(&str, "Slider at %d of %d", (int) pos,
+	    ui_slider_length(slider));
+	if (rv < 0) {
+		printf("Out of memory.\n");
+		return;
+	}
+
+	rc = ui_entry_set_text(demo->entry, str);
+	if (rc != EOK)
+		printf("Error changing entry text.\n");
+	(void) ui_entry_paint(demo->entry);
+
+	free(str);
+}
+
+/** Display a message window.
+ *
+ * @param demo UI demo
+ * @param caption Window caption
+ * @param text Message text
+ */
+static void uidemo_show_message(ui_demo_t *demo, const char *caption,
+    const char *text)
+{
+	ui_msg_dialog_params_t mdparams;
+	ui_msg_dialog_t *dialog;
+	errno_t rc;
+
+	ui_msg_dialog_params_init(&mdparams);
+	mdparams.caption = caption;
+	mdparams.text = text;
+
+	rc = ui_msg_dialog_create(demo->ui, &mdparams, &dialog);
+	if (rc != EOK) {
+		printf("Error creating message dialog.\n");
+		return;
+	}
+
+	ui_msg_dialog_set_cb(dialog, &msg_dialog_cb, &demo);
+}
+
+
+/** File/load menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (demo)
+ */
+static void uidemo_file_load(ui_menu_entry_t *mentry, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	ui_file_dialog_params_t fdparams;
+	ui_file_dialog_t *dialog;
+	errno_t rc;
+
+	ui_file_dialog_params_init(&fdparams);
+	fdparams.caption = "Load File";
+
+	rc = ui_file_dialog_create(demo->ui, &fdparams, &dialog);
+	if (rc != EOK) {
+		printf("Error creating message dialog.\n");
+		return;
+	}
+
+	ui_file_dialog_set_cb(dialog, &file_dialog_cb, demo);
+}
+
+/** File/message menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (demo)
+ */
+static void uidemo_file_message(ui_menu_entry_t *mentry, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	ui_msg_dialog_params_t mdparams;
+	ui_msg_dialog_t *dialog;
+	errno_t rc;
+
+	ui_msg_dialog_params_init(&mdparams);
+	mdparams.caption = "Message For You";
+	mdparams.text = "Hello, world!";
+
+	rc = ui_msg_dialog_create(demo->ui, &mdparams, &dialog);
+	if (rc != EOK) {
+		printf("Error creating message dialog.\n");
+		return;
+	}
+
+	ui_msg_dialog_set_cb(dialog, &msg_dialog_cb, &demo);
+}
+
+/** File/exit menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (demo)
+ */
+static void uidemo_file_exit(ui_menu_entry_t *mentry, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	ui_quit(demo->ui);
+}
+
+/** File dialog OK button press.
+ *
+ * @param dialog File dialog
+ * @param arg Argument (ui_demo_t *)
+ * @param fname File name
+ */
+static void file_dialog_bok(ui_file_dialog_t *dialog, void *arg,
+    const char *fname)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	char buf[128];
+	char *p;
+	FILE *f;
+
+	ui_file_dialog_destroy(dialog);
+
+	f = fopen(fname, "rt");
+	if (f == NULL) {
+		uidemo_show_message(demo, "Error", "Error opening file.");
+		return;
+	}
+
+	p = fgets(buf, sizeof(buf), f);
+	if (p == NULL) {
+		uidemo_show_message(demo, "Error", "Error reading file.");
+		fclose(f);
+		return;
+	}
+
+	/* Cut string off at the first non-printable character */
+	p = buf;
+	while (*p != '\0') {
+		if (*p < ' ') {
+			*p = '\0';
+			break;
+		}
+		++p;
+	}
+
+	ui_entry_set_text(demo->entry, buf);
+	fclose(f);
+}
+
+/** File dialog cancel button press.
+ *
+ * @param dialog File dialog
+ * @param arg Argument (ui_demo_t *)
+ */
+static void file_dialog_bcancel(ui_file_dialog_t *dialog, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	(void) demo;
+	ui_file_dialog_destroy(dialog);
+}
+
+/** Message dialog close request.
+ *
+ * @param dialog File dialog
+ * @param arg Argument (ui_demo_t *)
+ */
+static void file_dialog_close(ui_file_dialog_t *dialog, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	(void) demo;
+	ui_file_dialog_destroy(dialog);
+}
+
+/** Message dialog button press.
+ *
+ * @param dialog Message dialog
+ * @param arg Argument (ui_demo_t *)
+ * @param bnum Button number
+ */
+static void msg_dialog_button(ui_msg_dialog_t *dialog, void *arg,
+    unsigned bnum)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	(void) demo;
+	ui_msg_dialog_destroy(dialog);
+}
+
+/** Message dialog close request.
+ *
+ * @param dialog Message dialog
+ * @param arg Argument (ui_demo_t *)
+ */
+static void msg_dialog_close(ui_msg_dialog_t *dialog, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	(void) demo;
+	ui_msg_dialog_destroy(dialog);
 }
 
@@ -110,4 +401,11 @@
 	gfx_bitmap_t *bitmap;
 	gfx_coord2_t off;
+	ui_menu_entry_t *mmsg;
+	ui_menu_entry_t *mload;
+	ui_menu_entry_t *mfoo;
+	ui_menu_entry_t *mbar;
+	ui_menu_entry_t *mfoobar;
+	ui_menu_entry_t *mexit;
+	ui_menu_entry_t *mabout;
 	errno_t rc;
 
@@ -117,15 +415,24 @@
 		return rc;
 	}
+
+	memset((void *) &demo, 0, sizeof(demo));
+	demo.ui = ui;
 
 	ui_wnd_params_init(&params);
 	params.caption = "UI Demo";
 	params.style |= ui_wds_resizable;
-	params.rect.p0.x = 0;
-	params.rect.p0.y = 0;
-	params.rect.p1.x = 220;
-	params.rect.p1.y = 180;
-
-	memset((void *) &demo, 0, sizeof(demo));
-	demo.ui = ui;
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		params.rect.p0.x = 0;
+		params.rect.p0.y = 0;
+		params.rect.p1.x = 80;
+		params.rect.p1.y = 25;
+	} else {
+		params.rect.p0.x = 0;
+		params.rect.p0.y = 0;
+		params.rect.p1.x = 220;
+		params.rect.p1.y = 350;
+	}
 
 	rc = ui_window_create(ui, &params, &window);
@@ -147,4 +454,136 @@
 	}
 
+	rc = ui_menu_bar_create(ui, window, &demo.mbar);
+	if (rc != EOK) {
+		printf("Error creating menu bar.\n");
+		return rc;
+	}
+
+	rc = ui_menu_create(demo.mbar, "File", &demo.mfile);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(demo.mfile, "Message", "", &mmsg);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	ui_menu_entry_set_cb(mmsg, uidemo_file_message, (void *) &demo);
+
+	rc = ui_menu_entry_create(demo.mfile, "Load", "", &mload);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	ui_menu_entry_set_cb(mload, uidemo_file_load, (void *) &demo);
+
+	rc = ui_menu_entry_create(demo.mfile, "Foo", "Ctrl-Alt-Del", &mfoo);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(demo.mfile, "Bar", "", &mbar);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(demo.mfile, "Foobar", "", &mfoobar);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_sep_create(demo.mfile, &mexit);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(demo.mfile, "Exit", "Alt-F4", &mexit);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	ui_menu_entry_set_cb(mexit, uidemo_file_exit, (void *) &demo);
+
+	rc = ui_menu_create(demo.mbar, "Edit", &demo.medit);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_create(demo.mbar, "Preferences", &demo.mpreferences);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_create(demo.mbar, "Help", &demo.mhelp);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(demo.mhelp, "About", "Ctrl-H, F1", &mabout);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 1;
+		rect.p0.y = 2;
+		rect.p1.x = 79;
+		rect.p1.y = 3;
+	} else {
+		rect.p0.x = 4;
+		rect.p0.y = 30;
+		rect.p1.x = 216;
+		rect.p1.y = 52;
+	}
+	ui_menu_bar_set_rect(demo.mbar, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_menu_bar_ctl(demo.mbar));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_entry_create(window, "", &demo.entry);
+	if (rc != EOK) {
+		printf("Error creating entry.\n");
+		return rc;
+	}
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 20;
+		rect.p0.y = 4;
+		rect.p1.x = 60;
+		rect.p1.y = 5;
+	} else {
+		rect.p0.x = 15;
+		rect.p0.y = 53;
+		rect.p1.x = 205;
+		rect.p1.y = 78;
+	}
+
+	ui_entry_set_rect(demo.entry, &rect);
+	ui_entry_set_halign(demo.entry, gfx_halign_center);
+
+	rc = ui_fixed_add(demo.fixed, ui_entry_ctl(demo.entry));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
 	rc = ui_label_create(ui_res, "Text label", &demo.label);
 	if (rc != EOK) {
@@ -153,8 +592,17 @@
 	}
 
-	rect.p0.x = 60;
-	rect.p0.y = 37;
-	rect.p1.x = 160;
-	rect.p1.y = 50;
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 20;
+		rect.p0.y = 6;
+		rect.p1.x = 60;
+		rect.p1.y = 7;
+	} else {
+		rect.p0.x = 60;
+		rect.p0.y = 88;
+		rect.p1.x = 160;
+		rect.p1.y = 101;
+	}
+
 	ui_label_set_rect(demo.label, &rect);
 	ui_label_set_halign(demo.label, gfx_halign_center);
@@ -174,8 +622,17 @@
 	ui_pbutton_set_cb(demo.pb1, &pbutton_cb, (void *) &demo);
 
-	rect.p0.x = 15;
-	rect.p0.y = 70;
-	rect.p1.x = 105;
-	rect.p1.y = 98;
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 20;
+		rect.p0.y = 8;
+		rect.p1.x = 30;
+		rect.p1.y = 9;
+	} else {
+		rect.p0.x = 15;
+		rect.p0.y = 111;
+		rect.p1.x = 105;
+		rect.p1.y = 139;
+	}
+
 	ui_pbutton_set_rect(demo.pb1, &rect);
 
@@ -196,30 +653,19 @@
 	ui_pbutton_set_cb(demo.pb2, &pbutton_cb, (void *) &demo);
 
-	rect.p0.x = 115;
-	rect.p0.y = 70;
-	rect.p1.x = 205;
-	rect.p1.y = 98;
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 50;
+		rect.p0.y = 8;
+		rect.p1.x = 60;
+		rect.p1.y = 9;
+	} else {
+		rect.p0.x = 115;
+		rect.p0.y = 111;
+		rect.p1.x = 205;
+		rect.p1.y = 139;
+	}
+
 	ui_pbutton_set_rect(demo.pb2, &rect);
 
 	rc = ui_fixed_add(demo.fixed, ui_pbutton_ctl(demo.pb2));
-	if (rc != EOK) {
-		printf("Error adding control to layout.\n");
-		return rc;
-	}
-
-	rc = ui_entry_create(ui_res, "", &demo.entry);
-	if (rc != EOK) {
-		printf("Error creating entry.\n");
-		return rc;
-	}
-
-	rect.p0.x = 15;
-	rect.p0.y = 110;
-	rect.p1.x = 205;
-	rect.p1.y = 135;
-	ui_entry_set_rect(demo.entry, &rect);
-	ui_entry_set_halign(demo.entry, gfx_halign_center);
-
-	rc = ui_fixed_add(demo.fixed, ui_entry_ctl(demo.entry));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -248,5 +694,5 @@
 
 	off.x = 15;
-	off.y = 145;
+	off.y = 155;
 	gfx_rect_translate(&off, &bparams.rect, &rect);
 
@@ -258,4 +704,111 @@
 
 	rc = ui_fixed_add(demo.fixed, ui_image_ctl(demo.image));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_checkbox_create(ui_res, "Read only", &demo.checkbox);
+	if (rc != EOK) {
+		printf("Error creating check box.\n");
+		return rc;
+	}
+
+	ui_checkbox_set_cb(demo.checkbox, &checkbox_cb, (void *) &demo);
+
+	rect.p0.x = 15;
+	rect.p0.y = 190;
+	rect.p1.x = 140;
+	rect.p1.y = 210;
+	ui_checkbox_set_rect(demo.checkbox, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_checkbox_ctl(demo.checkbox));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_rbutton_group_create(ui_res, &demo.rbgroup);
+	if (rc != EOK) {
+		printf("Error creating radio button group.\n");
+		return rc;
+	}
+
+	rc = ui_rbutton_create(demo.rbgroup, "Left", (void *) &uidemo_halign[0],
+	    &demo.rbleft);
+	if (rc != EOK) {
+		printf("Error creating radio button.\n");
+		return rc;
+	}
+
+	ui_rbutton_group_set_cb(demo.rbgroup, &rbutton_group_cb,
+	    (void *) &demo);
+
+	rect.p0.x = 15;
+	rect.p0.y = 220;
+	rect.p1.x = 140;
+	rect.p1.y = 240;
+	ui_rbutton_set_rect(demo.rbleft, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbleft));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_rbutton_create(demo.rbgroup, "Center", (void *) &uidemo_halign[1],
+	    &demo.rbcenter);
+	if (rc != EOK) {
+		printf("Error creating radio button.\n");
+		return rc;
+	}
+
+	rect.p0.x = 15;
+	rect.p0.y = 250;
+	rect.p1.x = 140;
+	rect.p1.y = 270;
+	ui_rbutton_set_rect(demo.rbcenter, &rect);
+	ui_rbutton_select(demo.rbcenter);
+
+	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbcenter));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_rbutton_create(demo.rbgroup, "Right", (void *) &uidemo_halign[2],
+	    &demo.rbright);
+	if (rc != EOK) {
+		printf("Error creating radio button.\n");
+		return rc;
+	}
+
+	rect.p0.x = 15;
+	rect.p0.y = 280;
+	rect.p1.x = 140;
+	rect.p1.y = 300;
+	ui_rbutton_set_rect(demo.rbright, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbright));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_slider_create(ui_res, "Slide!", &demo.slider);
+	if (rc != EOK) {
+		printf("Error creating button.\n");
+		return rc;
+	}
+
+	ui_slider_set_cb(demo.slider, &slider_cb, (void *) &demo);
+
+	rect.p0.x = 15;
+	rect.p0.y = 310;
+	rect.p1.x = 130;
+	rect.p1.y = 330;
+	ui_slider_set_rect(demo.slider, &rect);
+
+	rc = ui_fixed_add(demo.fixed, ui_slider_ctl(demo.slider));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
Index: uspace/app/uidemo/uidemo.h
===================================================================
--- uspace/app/uidemo/uidemo.h	(revision 5b9993b49f8397a774a9ba98c8299b2b7d423b56)
+++ uspace/app/uidemo/uidemo.h	(revision 3a4a944f9be64d2ec90b47d2a2e5502e505d46a4)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2021 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,8 +38,13 @@
 
 #include <display.h>
+#include <ui/checkbox.h>
 #include <ui/entry.h>
 #include <ui/fixed.h>
 #include <ui/label.h>
+#include <ui/menu.h>
+#include <ui/menubar.h>
 #include <ui/pbutton.h>
+#include <ui/rbutton.h>
+#include <ui/slider.h>
 #include <ui/ui.h>
 #include <ui/window.h>
@@ -50,4 +55,9 @@
 	ui_window_t *window;
 	ui_fixed_t *fixed;
+	ui_menu_bar_t *mbar;
+	ui_menu_t *mfile;
+	ui_menu_t *medit;
+	ui_menu_t *mpreferences;
+	ui_menu_t *mhelp;
 	ui_entry_t *entry;
 	ui_image_t *image;
@@ -55,4 +65,10 @@
 	ui_pbutton_t *pb1;
 	ui_pbutton_t *pb2;
+	ui_checkbox_t *checkbox;
+	ui_rbutton_group_t *rbgroup;
+	ui_rbutton_t *rbleft;
+	ui_rbutton_t *rbcenter;
+	ui_rbutton_t *rbright;
+	ui_slider_t *slider;
 } ui_demo_t;
 
